#include "../../SDK/foobar2000/SDK/foobar2000.h"
#include "../../SDK/foobar2000/helpers/helpers.h"

DECLARE_COMPONENT_VERSION(
	// component name
	"Playlist Commandline Tools",
	// component version
	"0.0.1",
	// about text
	"Component to allow manipulation of playlists from the command line\n"
	"\n"
	"Usage:\n"
	"\t/playlist-activate:{\"name\"|index}\n"
	"\n"
	"Examples:\n"
	"\t/playlist-activate:\"Default\"\n"
	"\t\tActivates the playlist named \"Default\"\n"
	"\t/playlist-activate:0\n"
	"\t\tActivates the first playlist"
	)

class PlaylistCommandLineHandler : public commandline_handler
{
	virtual result on_token(const char * token)
	{
		console::info(token);
		if(pfc::strcmp_partial(token, "/playlist-activate:") == 0)
		{
			static_api_ptr_t<playlist_manager> playlistManager;
			
			const char * playlistname = &token[sizeof("/playlist-activate:")-1];

			t_size playlistIndex;
			if(pfc::string_is_numeric(playlistname))
			{
				playlistIndex = atoi(playlistname);
			}
			else
			{
				playlistIndex = playlistManager->find_playlist(playlistname, strlen(playlistname));
			}
			playlistManager->set_active_playlist(playlistIndex);
			return result::RESULT_PROCESSED;
		}

		return result::RESULT_NOT_OURS;
	}
};

static commandline_handler_factory_t< PlaylistCommandLineHandler > foo_commandline_handler;